#ifndef _MatrixUltrasonicSensor_H_
#define _MatrixUltrasonicSensor_H_

#include <Arduino.h>
#include <Wire.h>

#ifndef ADDR_PCA954X
#define ADDR_PCA954X 0x70
#endif

#define MatrixUR_ADDR 0x26

typedef enum __UltrasonicRegType
{
	Device_ID = 1,
	Device_Control,
	Device_Anime,
	Device_Sample_Rate,
	Device_Distance_H,
	Device_Distance_L
} UltrasonicRegType;

typedef enum __AnimeTypeType
{
	None = 0,
	Happy,
	Surprise,
	Cute_1,
	Cute_2,
	Cat,
	Angry,
	Sad,
	Frustrated
} AnimeType;

class MatrixUltrasonic{
private:
	uint8_t _ch=0, _ver=1;
	uint8_t i2cReadData(UltrasonicRegType reg);
	void i2cMUXSelect();
	void i2cWriteData(UltrasonicRegType reg, uint8_t data);
public:
	friend class MiniI2C;
	bool begin();

	void setAnime(AnimeType Anime);
	void setSR(int rate);
	
	uint16_t getDistance();
};

#endif
